Option Explicit

Function IsNothing(obj)
	IsNothing = (TypeName(obj) = "Nothing")
End Function

If WScript.Arguments.Count < 1 Then
	WScript.Echo "usage: cscript tester.vbs {CRC32|MD4|MD5|SHA1|RIPEMD128|RIPEMD160} ..."
	WScript.Quit
End If

Dim objFSO, objFile
Set objFSO = CreateObject("Scripting.FileSystemObject")

Dim blnUseUniversalHash, blnHMAC
blnUseUniversalHash = False
blnHMAC = False

Dim strHash, objHash
For Each strHash in WScript.Arguments
	If strHash = "+" Then
		Set objHash = Nothing
		blnUseUniversalHash = True
		WScript.Echo ""
		WScript.Echo "#######################################"
		WScript.Echo "##  Using the universal hash object  ##"
		WScript.Echo "#######################################"
		WScript.Echo ""
	ElseIf strHash = "-" Then
		Set objHash = Nothing
		blnUseUniversalHash = False
		WScript.Echo ""
		WScript.Echo "#######################################"
		WScript.Echo "##  Using individual hash objects    ##"
		WScript.Echo "#######################################"
		WScript.Echo ""
	Else
		Dim strLine, intPos, strHashTest, strFileName, strHashValue

		Set objFile = objFSO.OpenTextFile(strHash & ".lst")
		If blnUseUniversalHash Then
			intPos = InStr(strHash, "-")
			If intPos = 0 Then
				If IsNothing(objHash) Or blnHMAC Then
					Set objHash = CreateObject("ZmeYsoft.Hashes.Hash")
					blnHMAC = False
				End If
			Else
				If IsNothing(objHash) Or Not blnHMAC Then
					Set objHash = CreateObject("ZmeYsoft.HMACs.HMAC")
					blnHMAC = True
				End If
			End If
			objHash.Algorithm = strHash
		Else
			Dim strProgId
			intPos = InStr(strHash, "-")
			If intPos = 0 Then
				strProgId = "ZmeYsoft.Hashes." & strHash
			Else
				strProgId = "ZmeYsoft.HMACs." & Mid(strHash, intPos + 1)
			End If
			Set objHash = CreateObject(strProgId)
		End If

		WScript.Echo "---- " & objHash.Algorithm & " ----"

		While Not objFile.AtEndOfStream
			strLine = objFile.ReadLine
			WScript.Echo strLine
			intPos = InStr(strLine, " ")
			If intPos > 1 Then
				strHashTest = Left(strLine, intPos - 1)
				strFileName = Mid(strLine, intPos + 1)
				If LCase(strFileName) = "key" Then
					objHash.Key = strHashTest
				Else
					objHash.HashFile strFileName
					strHashValue = objHash.Value
					objHash.Reset
					If InStr(strHashTest, strHashValue) = 1 Then
						WScript.Echo strHashValue & " OK"
					Else
						WScript.Echo strHashValue & " *** Failed!"
					End If
					WScript.Echo ""
				End If
			End If
		Wend
	End If
Next
